/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package vip.xiaonuo.disk.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import vip.xiaonuo.auth.core.util.StpLoginUserUtil;
import vip.xiaonuo.common.enums.CommonSortOrderEnum;
import vip.xiaonuo.common.exception.CommonException;
import vip.xiaonuo.common.page.CommonPageRequest;
import vip.xiaonuo.disk.domain.CourseInfo;
import vip.xiaonuo.disk.domain.CourseNotebooks;
import vip.xiaonuo.disk.domain.CourseNotes;
import vip.xiaonuo.disk.mapper.CourseInfoMapper;
import vip.xiaonuo.disk.mapper.CourseNotebooksMapper;
import vip.xiaonuo.disk.mapper.CourseNotesMapper;
import vip.xiaonuo.disk.param.CourseNotesAddParam;
import vip.xiaonuo.disk.param.CourseNotesEditParam;
import vip.xiaonuo.disk.param.CourseNotesIdParam;
import vip.xiaonuo.disk.param.CourseNotesPageParam;
import vip.xiaonuo.disk.service.CourseNotesService;

import javax.annotation.Resource;
import java.util.List;

/**
 * 课程笔记表Service接口实现类
 *
 * @author 金吉龙
 * @date  2025/07/01 18:56
 **/
@Service
public class CourseNotesServiceImpl extends ServiceImpl<CourseNotesMapper, CourseNotes> implements CourseNotesService {


    @Resource
    private CourseInfoMapper courseInfoMapper;

    @Resource
    private CourseNotesMapper courseNotesMapper;

    @Resource
    private CourseNotebooksMapper courseNotebooksMapper;


    @Override
    public Page<CourseNotes> page(CourseNotesPageParam courseNotesPageParam) {
        QueryWrapper<CourseNotes> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isAllNotEmpty(courseNotesPageParam.getSortField(), courseNotesPageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(courseNotesPageParam.getSortOrder());
            queryWrapper.orderBy(true, courseNotesPageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(courseNotesPageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByAsc(CourseNotes::getNoteId);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(CourseNotesAddParam courseNotesAddParam) {
        CourseNotes courseNotes = BeanUtil.toBean(courseNotesAddParam, CourseNotes.class);
        // 校验当前课程是否有笔记本
        // 1.根据章节查询课程
        CourseInfo courseInfo = courseInfoMapper.selectById(courseNotesAddParam.getChapterId());
        if(ObjectUtil.isEmpty(courseInfo)) {
            throw new CommonException("课程不存在，id值为：{}", courseNotesAddParam.getChapterId());
        }
        // 2.判断当前课程是否有笔记本
        QueryWrapper<CourseNotebooks> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(CourseNotebooks::getCourseId, courseInfo.getCourseId());
        queryWrapper.lambda().eq(CourseNotebooks::getUserId, StpLoginUserUtil.getLoginUser().getId());
        CourseNotebooks courseNotebooks = courseNotebooksMapper.selectOne(queryWrapper);
        // 如果没有笔记本，则创建笔记本
        if (courseNotebooks == null) {
            CourseNotebooks newCourseNotebooks = new CourseNotebooks();
            courseNotebooks.setUserId(StpLoginUserUtil.getLoginUser().getId()); // 用户id
            String notebookId = IdUtil.fastSimpleUUID();
            courseNotebooks.setNotebookId(notebookId); // 主键id
            courseNotebooks.setCourseId(courseInfo.getCourseId()); // 课程id
            courseNotebooksMapper.insert(newCourseNotebooks);
            courseNotebooks.setNotebookId(notebookId);
        }
        // 3.保存笔记信息
        courseNotes.setUserId(StpLoginUserUtil.getLoginUser().getId()); // 用户id
        courseNotes.setNotebookId(courseNotebooks.getNotebookId()); // 笔记本id
        this.save(courseNotes);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(CourseNotesEditParam courseNotesEditParam) {
        CourseNotes courseNotes = this.queryEntity(courseNotesEditParam.getNoteId());
        BeanUtil.copyProperties(courseNotesEditParam, courseNotes);
        this.updateById(courseNotes);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<CourseNotesIdParam> courseNotesIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(courseNotesIdParamList, CourseNotesIdParam::getNoteId));
    }

    @Override
    public CourseNotes detail(CourseNotesIdParam courseNotesIdParam) {
        return this.queryEntity(courseNotesIdParam.getNoteId());
    }

    @Override
    public CourseNotes queryEntity(String id) {
        CourseNotes courseNotes = this.getById(id);
        if(ObjectUtil.isEmpty(courseNotes)) {
            throw new CommonException("课程笔记表不存在，id值为：{}", id);
        }
        return courseNotes;
    }

    @Override
    public CourseNotes getByChapterId(CourseNotesAddParam courseNotesAddParam) {
        QueryWrapper<CourseNotes> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(CourseNotes::getChapterId, courseNotesAddParam.getChapterId());
        queryWrapper.lambda().eq(CourseNotes::getUserId, StpLoginUserUtil.getLoginUser().getId());
        return this.getOne(queryWrapper);
    }

}
